<%@ WebService Language="C#" class="RemoteStudy" %>
/*

FastPACS
2006-2009 by Precision Diagnostic Systems, Inc.
Maple Park, IL 60151 USA


On-Line Support
Contents copyright Precision Diagnostic Systems, Inc.
Maple Park, IL 60151 USA

*/

	using System.Web.Services;
	using System;
	using System.Collections;
	using System.Data;
	using System.Data.OleDb;
	using System.Xml;
	using DIOWave;

	//==============================
	//
	//
	//
	//==============================
	public class StudyObject {

		public Int32 SEQ_NO;
		public String VOLUME;
		public String LOCATION;
		public String PATH;
		public String REF_FILE;
		public String STUDY_DT;
		public String PatientID;
		public String PatientName;
		public String StudyDate;
		public String StudyTime;
		public String StudyID;
		public String Modality;

		static int ord_SEQ_NO;
		static int ord_VOLUME;
		static int ord_PATH;
		static int ord_REF_FILE;
		static int ord_STUDY_DT;
		static int ord_PatientID;
		static int ord_PatientName;
		static int ord_StudyDate;
		static int ord_StudyTime;
		static int ord_StudyID;
		static int ord_Modality;

		static bool ordinals_inited = false;
		static public void init_ordinals(IDataReader reader) {
			ord_SEQ_NO = reader.GetOrdinal("SEQ_NO");
			ord_VOLUME = reader.GetOrdinal("VOLUME");
			ord_PATH = reader.GetOrdinal("PATH");
			ord_REF_FILE = reader.GetOrdinal("REF_FILE");
			ord_STUDY_DT = reader.GetOrdinal("STUDY_DT");
			ord_PatientID = reader.GetOrdinal("PatientID");
			ord_PatientName = reader.GetOrdinal("PatientName");
			ord_StudyDate = reader.GetOrdinal("StudyDate");
			ord_StudyTime = reader.GetOrdinal("StudyTime");
			ord_StudyID = reader.GetOrdinal("StudyID");
			ord_Modality = reader.GetOrdinal("Modality");
			ordinals_inited = true;
		}

		public StudyObject() {}

		public StudyObject(IDataReader reader, XmlDocument config_dom) {
			if (!ordinals_inited)
				init_ordinals(reader);

			SEQ_NO = reader.GetInt32(ord_SEQ_NO);
			VOLUME = reader.GetString(ord_VOLUME);
			LOCATION = config_dom.SelectSingleNode("/DIOWaveConfiguration/VOLUME[@label=\"" + VOLUME + "\"]/location").InnerText;
			PATH = reader.GetString(ord_PATH);
			REF_FILE = reader.GetString(ord_REF_FILE);
			STUDY_DT = reader.GetString(ord_STUDY_DT);
			PatientID = reader.GetString(ord_PatientID);
			PatientName = reader.GetString(ord_PatientName);
			StudyDate = reader.GetString(ord_StudyDate);
			StudyTime = reader.GetString(ord_StudyTime);
			StudyID = reader.GetString(ord_StudyID);
			Modality = reader.GetString(ord_Modality);
		}
	}

	//==============================
	//
	//
	//
	//==============================
	[WebService(Namespace="http://dicom.mi.hama-med.ac.jp/")]
	public class RemoteStudy : WebService {

		//==============================
		//
		//==============================
		[WebMethod]
		public StudyObject[] SelectStudies(String where) {

			XmlDocument config_dom = (XmlDocument)Application.Get("DIOWaveConf");

			ArrayList study_list = new ArrayList();

			String dataSource = config_dom.SelectSingleNode("/DIOWaveConfiguration/DATABASE/data-source").InnerText;
			OleDbConnection conn = new OleDbConnection(dataSource);
			conn.Open();
			OleDbCommand cmd = new OleDbCommand("SELECT * FROM DICOMSTUDY " + where, conn);
			OleDbDataReader reader = cmd.ExecuteReader();
			while (reader.Read()) {
				StudyObject study = new StudyObject(reader, config_dom);
				study_list.Add(study);
			}
			reader.Close();
			conn.Close();

			int index = 0;
			StudyObject[] study_array = new StudyObject[study_list.Count];
			foreach (StudyObject so in study_list)
				study_array[index++] = so;

			return study_array;
		}

	}

