<HTML>
<!--

FastPACS

2006-2010 
by Precision Diagnostic Systems, Inc.
Maple Park, IL 60151 USA
mod: 790, 718, 758, 759
-->
<%@ Import Namespace="System.Xml" %>
<%@ Import Namespace="System.Globalization" %>
<%@ Import Namespace="System.Data" %>
<%@ Import Namespace="System.Data.OleDb" %>
<%@ Import Namespace="DIOWave" %>
<%@ Import Namespace="System.IO" %>
<script src="classes.cs" runat="server" />
<script src="list-custom.cs" runat="server" />
<script runat="server">
//========================================================================================
	//==============================
	//
	//==============================
	XmlNodeList server_list;

	//==============================
	//
	//==============================
	TextWriter Writer;

	//==============================
	//
	//==============================
	String view_frame_width(bool multi_server) {
		switch (m_browser.type) {
		case "NN":
		case "GE":
		case "OP":
			return "top.VIEW.innerWidth";
		case "IE":
			if (!multi_server) {
				return "top.VIEW.document.body.offsetWidth";
			} else {
				if (m_browser.os == "M") {
					return "(top.document.body.offsetWidth - document.body.offsetWidth - (document.body.offsetHeight == document.body.clientHeight ? 2 : 18))";
				} else {
					return "(top.document.body.offsetWidth - document.body.offsetWidth - 6)";
				}
			}
		default:
			return "400";
		}
	}

	//==============================
	//
	//==============================
	String view_frame_height(bool multi_server) {
		switch (m_browser.type) {
		case "NN":
		case "GE":
		case "OP":
			return "top.VIEW.innerHeight";
		case "IE":
			if (!multi_server) {
				return "top.VIEW.document.body.offsetHeight";
			} else {
				if (m_browser.os == "M") {
					return "top.LIST.document.body.clientHeight";
				} else {
					return "top.LIST.document.body.offsetHeight";
				}
			}
		default:
			return "400";
		}
	}

	//==============================
	//
	//
	//
	//==============================
	class QueryStringValue : QueryStringValueBase {
		public String PatientID;
		public String PatientID_OP;
		public String PatientName;
		public String PatientName_OP;
		public String Patient_COMB;
		public String StudyDate;
		public String Modality;
		public Int32 SEQ_NO;
		public String VOLUME;
		public String PATH;
		public String SERVER;

		public QueryStringValue(HttpRequest req)
			: base(req) {
			PatientID = get_opt_str("PatientID", null);
			PatientID_OP = get_opt_str("PatientID-OP", "EQ");
			PatientName = get_opt_str("PatientName", null);
			PatientName_OP = get_opt_str("PatientName-OP", "EQ");
			Patient_COMB = get_opt_str("Patient-COMB", "AND");
			StudyDate = get_opt_str("StudyDate", null);
			Modality = get_opt_str("Modality", null);
			SEQ_NO = get_opt_int("SEQ_NO", 0);
			VOLUME = get_opt_str("VOLUME", null);
			PATH = get_opt_str("PATH", null);
			SERVER = get_opt_str("SERVER", null);
		}
	}

	//==============================
	//
	//
	//
	//==============================
	class StudyObject {

		public String SERVER;

		public Int32 SEQ_NO;
		public String VOLUME;
		public String LOCATION;
		public String PATH;
		public String REF_FILE;
		public String STUDY_DT;
		public String PatientID;
		public String PatientName;
		public String StudyDate;
		public String StudyTime;
		public String StudyID;
		public String Modality;

		static int ord_SEQ_NO;
		static int ord_VOLUME;
		static int ord_PATH;
		static int ord_REF_FILE;
		static int ord_STUDY_DT;
		static int ord_PatientID;
		static int ord_PatientName;
		static int ord_StudyDate;
		static int ord_StudyTime;
		static int ord_StudyID;
		static int ord_Modality;

		static bool ordinals_inited = false;
		static public void init_ordinals(IDataReader reader) {
			ord_SEQ_NO = reader.GetOrdinal("SEQ_NO");
			ord_VOLUME = reader.GetOrdinal("VOLUME");
			ord_PATH = reader.GetOrdinal("PATH");
			ord_REF_FILE = reader.GetOrdinal("REF_FILE");
			ord_STUDY_DT = reader.GetOrdinal("STUDY_DT");
			ord_PatientID = reader.GetOrdinal("PatientID");
			ord_PatientName = reader.GetOrdinal("PatientName");
			ord_StudyDate = reader.GetOrdinal("StudyDate");
			ord_StudyTime = reader.GetOrdinal("StudyTime");
			ord_StudyID = reader.GetOrdinal("StudyID");
			ord_Modality = reader.GetOrdinal("Modality");
			ordinals_inited = true;
		}

		public StudyObject(IDataReader reader) {

			if (!ordinals_inited)
				init_ordinals(reader);

			this.SERVER = null;

			this.SEQ_NO = reader.GetInt32(ord_SEQ_NO);
			this.VOLUME = reader.GetString(ord_VOLUME);
			this.LOCATION = null;
			this.PATH = reader.GetString(ord_PATH);
			this.REF_FILE = reader.GetString(ord_REF_FILE);
			this.STUDY_DT = reader.GetString(ord_STUDY_DT);
			this.PatientID = reader.GetString(ord_PatientID);
			this.PatientName = reader.GetString(ord_PatientName);
			this.StudyDate = reader.GetString(ord_StudyDate);
			this.StudyTime = reader.GetString(ord_StudyTime);
			this.StudyID = reader.GetString(ord_StudyID);
			this.Modality = reader.GetString(ord_Modality);
		}

		public StudyObject(DIOWaveRemote.StudyObject rso, String server) {
			this.SERVER = server;

			this.SEQ_NO = rso.SEQ_NO;
			this.VOLUME = rso.VOLUME;
			this.LOCATION = rso.LOCATION;
			this.PATH = rso.PATH;
			this.REF_FILE = rso.REF_FILE;
			this.STUDY_DT = rso.STUDY_DT;
			this.PatientID = rso.PatientID;
			this.PatientName = rso.PatientName;
			this.StudyDate = rso.StudyDate;
			this.StudyTime = rso.StudyTime;
			this.StudyID = rso.StudyID;
			this.Modality = rso.Modality;
		}
	}

	//==============================
	// 
	//
	//
	//==============================
	class ComparableEntityObject : IComparable {
		public String uid;
		public Int32 number;
		protected Double dt;

		protected void init(String date_str, String time_str, String number_str, String uid_str) {
			uid = uid_str;

			String dt = String.Empty;
			if (date_str != String.Empty)
				dt += normalizeDate(date_str);
			if (time_str != String.Empty)
				dt += normalizeTime(time_str);
			if (dt != String.Empty)
				this.dt = Double.Parse(dt);

			if (number_str != String.Empty)
				this.number = Int32.Parse(number_str, IS_ns);
		}

		public int CompareTo(Object obj) {
			ComparableEntityObject rhs = (ComparableEntityObject)obj;

			Double dr = this.dt - rhs.dt;
			if (dr != 0.0)
				return (int)dr;

			int ir = this.number - rhs.number;
			if (ir != 0)
				return ir;

			return String.Compare(this.uid, rhs.uid);
		}
	}

	//==============================
	//
	//
	//
	//==============================
	class SeriesObject : ComparableEntityObject {
		public UInt32 num_images;
		public SOPInstanceObject ref_file;

		public SeriesObject(DicomStudy dom, DataElementObject series_uid_obj) {

			this.num_images = 0;
			this.ref_file = null;
			foreach (SOPInstanceObject f in dom.fl) {
				foreach (DataElementObject deo in f.data) {
					if (deo != series_uid_obj)
						continue;
					if (this.ref_file == null)
						this.ref_file = f;
					this.num_images++;
					break;
				}
			}

			String date = String.Empty;
			String time = String.Empty;
			String number = String.Empty;
			String uid = String.Empty;

			foreach (DataElementObject deo in this.ref_file.data) {
				if (deo.tag < 0x00080021) {
					continue;
				} else if (deo.tag > 0x00080031 && deo.tag < 0x0020000E) {
					continue;
				} else if (deo.tag == 0x00080021) {
					if (deo.value != null)
						date = (String)deo.value;
				} else if (deo.tag == 0x00080031) {
					if (deo.value != null)
						time = (String)deo.value;
				} else if (deo.tag == 0x0020000E) {
					uid = (String)deo.value;
				} else if (deo.tag == 0x00200011) {
					if (deo.value != null)
						number = (String)deo.value;
					break;
				} else if (deo.tag > 0x00200011) {
					break;
				}
			}

			init(date, time, number, uid);
		}
	}

	//==============================
	// 
	//==============================
	class ImageObject : ComparableEntityObject {
		public SOPInstanceObject file;
		public String time;

		public ImageObject(DicomStudy dom, SOPInstanceObject file) {

			this.file = file;

			String date = String.Empty;
			String time = String.Empty;
			String number = String.Empty;
			String uid = String.Empty;

			foreach (DataElementObject deo in this.file.data) {
				if (deo.tag < 0x00080018) {
					continue;
				} else if (deo.tag > 0x00080033 && deo.tag < 0x00200013) {
					continue;
				} else if (deo.tag == 0x00080018) {
					uid = (String)deo.value;
				} else if (deo.tag == 0x00080023) {
					if (deo.value != null)
						date = (String)deo.value;
				} else if (deo.tag == 0x00080033) {
					if (deo.value != null)
						time = (String)deo.value;
				} else if (deo.tag == 0x00200013) {
					if (deo.value != null)
						number = (String)deo.value;
					break;
				} else if (deo.tag > 0x00200013) {
					break;
				}
			}

			this.time = time;

			init(date, time, number, uid);
		}
	}

	//==============================
	//
	//==============================
	String image_url(StudyObject study, XmlElement vol_config) {
		String host = null;
		String location = null;
		if (study.SERVER == null) {
			host = String.Empty;
			location = vol_config.SelectSingleNode("location").InnerText;
		} else {
			host = "http://" + study.SERVER;
			location = study.LOCATION;
		}
		return host
		     + "/DIOWave/scripts/dio-image.isa"
		     + location
		     + '/'
		     + study.PATH
		     + '/'
		     + study.REF_FILE
		     + "?HEIGHT=48&WIDTH=48";
	}
	
	//==============================
	//
	//==============================
	String image_url2(StudyObject study, String path, XmlElement vol_config) {
		String host = null;
		String location = null;
		if (study.SERVER == null) {
			host = String.Empty;
			location = vol_config.SelectSingleNode("location").InnerText;
		} else {
			host = "http://" + study.SERVER;
			location = study.LOCATION;
		}
		return host
		     + "/DIOWave/scripts/dio-image.isa"
		     + location
		     + '/'
		     + study.PATH
		     + '/'
		     + path
		     + "?HEIGHT=48&WIDTH=48";
	}

	//==============================
	//
	//==============================
	String study_url(StudyObject study) {
		return "";
	/*
		var dir;
		switch (BROWSER.type) {
		case 'NN':
			dir = 'NS4';
			break;
		case 'IE':
			if (BROWSER.version >= 5.5)
				dir = 'IE5.5';
			else
				dir = 'IE4'
			break;
		}
			
		return 'http://' + study.SERVER
			+ '/scripts/dio-pages.isa?HTML=/' + dir + '/StudyBrowser/series.htm'
			+ '&FROM=' + config_dom.SelectSingleNode('/DIOWaveConfiguration/VOLUME[@label="' + rs('VOLUME') +'"]/location').text + '/' + study.PATH
			+ '&PatientID=' + escape(study.PatientID)
			+ '&PatientName=' + escape(study.PatientName)
			+ '&StudyDate=' + escape(study.StudyDate)
			+ '&StudyTime=' + escape(study.StudyTime)
			+ '&StudyID=' + escape(study.StudyID)
			+ '&Modality=' + escape(study.Modality);
	*/
	}

	//==============================
	//
	//==============================
	bool single_patient(ArrayList study_list) {
		String pid0 = ((StudyObject)study_list[0]).PatientID;
		Int32 pid0_len = pid0.Length;
		foreach (StudyObject study in study_list) {
			String pid = study.PatientID;
			if (pid.Length != pid0_len || pid0 != pid) {
				return false;
			}
		}
		return true;
	}

	//==============================
	//
	//==============================
	String expand_study_arg(StudyObject study) {
		return '"' + (study.SERVER != null ? study.SERVER : "") + "\"," + study.SEQ_NO + ",\"" + study.PatientID + "\",\"" + study.StudyDate + "\",\"" + study.Modality + '"';
	}

	//==============================
	// 
	//==============================
	String open_spatial_series_viewer_arg(StudyObject study, SeriesObject series) {
		return '"' + (study.SERVER != null ? study.SERVER : "") + "\",\"" + study.VOLUME + "\",\"" + study.PATH + "\",\"" + series.uid + '"';
	}
	//==============================
	// 
	//==============================
	String open_xp_study_viewer_arg(StudyObject study, String image_path) {
		return '"' + (study.SERVER != null ? study.SERVER : "") + "\",\"" + study.VOLUME + "\",\"" + study.PATH + "\",\"" + image_path + '"';
	}

	//==============================
	//
	//==============================
	String modality_query_sql(QueryStringValue qsv) {
		if (qsv.Modality == null)
			return "";

		String[] modality = qsv.Modality.Split(null);
		
		String sql = "";
		for (int i = 0; i < modality.Length; i++) {
			if (modality[i].Length == 0)
				continue;
			if (sql.Length > 0)
				sql += " OR ";
			sql += "Modality = '" + modality[i] + "'";
		}
		if (modality.Length > 1)
			sql = "(" + sql + ")";

		return sql;
	}

	//==============================
	//
	//==============================
	String opstr(String op, String val) {
		if (op == "EQ")
			return " = '" + val + "'";
		else if (op == "AB")
			return " LIKE '" + val + "%'";
		else if (op == "OP")
			return " LIKE '%" + val + "%'";
		else if (op == "YZ")
			return " LIKE '%" + val + "'";
		else
			return "";
	}

	//==============================
	//
	//==============================
	String patient_query_sql(QueryStringValue qsv) {

		String pid_sql = "";
		if (qsv.PatientID != null) {
			String pid = qsv.PatientID;
			if (reform_pid_flag) {
				pid = reform_pid_func(pid);
			}
			pid_sql = "PatientID" + opstr(qsv.PatientID_OP, pid);
		}
	
		String name_sql = "";
		if (qsv.PatientName != null)
			name_sql = "PatientName" + opstr(qsv.PatientName_OP, qsv.PatientName);
	
		String sql;
		if (pid_sql.Length > 0 && name_sql.Length > 0)
			sql = "(" + pid_sql + " " + qsv.Patient_COMB + " " + name_sql + ")";
		else
			sql = pid_sql + name_sql;
	
		return sql;
	}

	//==============================
	//
	//==============================
	String date_query_sql(QueryStringValue qsv) {
		if (qsv.StudyDate == null)
			return "";

		if (qsv.StudyDate.IndexOf("%") < 0)
			return "StudyDate = '" + qsv.StudyDate + "'";
		else
			return "StudyDate LIKE '" + qsv.StudyDate + "'";
	}

	//==============================
	//
	//==============================
	String gen_sql(QueryStringValue qsv) {
		if (qsv.SEQ_NO > 0)
			return " WHERE SEQ_NO = " + qsv.SEQ_NO;
		if (qsv.VOLUME != null && qsv.PATH != null)
			return " WHERE VOLUME = '" + qsv.VOLUME + "' AND PATH = '" + qsv.PATH + "'";
	
		String pq = patient_query_sql(qsv);
		String dq = date_query_sql(qsv);
		String mq = modality_query_sql(qsv);
	
		String where = pq;
		if (dq.Length != 0) {
			if (where.Length != 0)
				where += " AND ";
			where += dq;
		}
		if (mq.Length != 0) {
			if (where.Length != 0)
				where += " AND ";
			where += mq;
		}
		if (where.Length == 0) {
			Response.Clear();
			Server.Transfer("/DIOWave/blank1.htm");
		}
	
		return " WHERE " + where + extra_sql_cond + " ORDER BY STUDY_DT DESC";
	}

	//==============================
	//
	//==============================
	ArrayList local_study_list(String sql, XmlDocument config_dom) {
		ArrayList study_list = new ArrayList();

		String dataSource = config_dom.SelectSingleNode("/DIOWaveConfiguration/DATABASE/data-source").InnerText;
		OleDbConnection conn = new OleDbConnection(dataSource);
		conn.Open();
		OleDbCommand cmd = new OleDbCommand("SELECT * FROM DICOMSTUDY " + sql, conn);
		OleDbDataReader reader = cmd.ExecuteReader();
		while (reader.Read()) {
			StudyObject study = new StudyObject(reader);
			study_list.Add(study);
		}
		reader.Close();
		conn.Close();
	
		return study_list;
	}

	//==============================
	//
	//==============================
	ArrayList remote_study_list(String sql, String hostname) {
		DIOWaveRemote.RemoteStudy remote = new DIOWaveRemote.RemoteStudy("http://" + hostname + Request.ApplicationPath + "/remote.asmx");
		DIOWaveRemote.StudyObject[] study_array = remote.SelectStudies(sql);
		ArrayList study_list = new ArrayList();
		foreach (DIOWaveRemote.StudyObject rso in study_array) {
			StudyObject study = new StudyObject(rso, hostname);
			study_list.Add(study);
		}
		return study_list;
	}

	//==============================
	//
	//==============================
	ArrayList build_study_list(String sql, XmlDocument config_dom, QueryStringValue qsv) {

		if (qsv.SEQ_NO > 0) {
			if (qsv.SERVER == null)
				return local_study_list(sql, config_dom);
			else
				return remote_study_list(sql, qsv.SERVER);
		}

		ArrayList study_list = local_study_list(sql, config_dom);
		
		if (server_list.Count == 0)
			return study_list;

		foreach (XmlElement server in server_list) {
			String hostname = server.GetAttribute("hostname");
			ArrayList rem_study_list = remote_study_list(sql, hostname);

			if (study_list == null || study_list.Count == 0) {
				study_list = rem_study_list;
				continue;
			}

			ArrayList study_list_tmp = new ArrayList();
			int j = 0, k = 0;
			while (j < study_list.Count && k < rem_study_list.Count) {
				if (String.Compare(((StudyObject)rem_study_list[k]).STUDY_DT, ((StudyObject)study_list[j]).STUDY_DT) > 0) {
					study_list_tmp.Add(rem_study_list[k++]);
				} else {
					study_list_tmp.Add(study_list[j++]);
				}
			}
			while (j < study_list.Count) {
				study_list_tmp.Add(study_list[j++]);
			}
			while (k < rem_study_list.Count) {
				study_list_tmp.Add(rem_study_list[k++]);
			}
			study_list = study_list_tmp;
		}
		return study_list;
	}

	//==============================
	//
	//==============================
	void print_num_studies(UInt32 n) {
		String str = (n == 0) ? "No" : n.ToString();
		Writer.Write("<DIV CLASS='NUM-STUIDES'><B>" + str + " Studies Found</B></DIV>\n");
	}

	//==============================
	// 
	//==============================
	const int thumnail_table_width = 170;
	const int thumnail_border = 1;
	const int thumnail_size = 48;
	const int thumnail_info_indent = 4;
	const int thumnail_series_info_width = thumnail_table_width - thumnail_info_indent - thumnail_size - thumnail_border * 2;
	String thumnail_table_header = "<TABLE BORDER='0' CELLPADDING='0' CELLSPACING='0' HSPACE='0' VSPACE='0' WIDTH='" + thumnail_table_width + "' COLS='3'>\n"
		+ "<TR><TD WIDTH='" + thumnail_info_indent + "'></TD><TD WIDTH='" + thumnail_series_info_width + "'></TD><TD WIDTH='52'></TD></TR>\n";

	//==============================
	// 
	//==============================
	String thumnail_table_row_heaader(String id) {
		return "<TR><TD COLSPAN='3'><HR COLOR='#687686' NOSHADE WIDTH='120' ALIGN='CENTER'></TD></TR>\n"
		+ "<TR ID='" + id + "'>\n"
		+ "<TD></TD>\n"
		+ "<TD VALIGN='TOP' ALIGN='LEFT'><DIV CLASS='SERIES-INFO'>";
	}

	//==============================
	// 
	//==============================
	void print_data(SOPInstanceObject file, UInt32 tag, String label) {
		String data = (String)get_data(file, null, tag);
		if (data == null)
			return;
		Writer.Write("<BR>");
		if (m_browser.type != "NN")
			Writer.Write("<NOBR>");
		else
			Writer.Write("<SPAN>");
		Writer.Write(label);
		Writer.Write(": <FONT COLOR='white'>");
		Writer.Write(data);
		Writer.Write("</FONT>");
		if (m_browser.type != "NN")
			Writer.Write("</NOBR>");
		else
			Writer.Write("</SPAN>");
	}

	//==============================
	// 
	//==============================
	void spatial_study(DicomStudy dom, StudyObject study, XmlElement vol_config) {

		ArrayList seriesObj_list = new ArrayList();
		foreach (DataElementObject deo in dom.el) {
			if (deo.tag != 0x0020000E)
				continue;
			seriesObj_list.Add(new SeriesObject(dom, deo));
		}
		seriesObj_list.Sort();

		Writer.Write(thumnail_table_header);
		foreach (SeriesObject seriesObj in seriesObj_list) {
			Writer.Write(thumnail_table_row_heaader(seriesObj.uid));
			Writer.Write("<NOBR><FONT COLOR='white'># ");
			Writer.Write(seriesObj.number);
			Writer.Write(" [ ");
			Writer.Write(seriesObj.num_images);
			Writer.Write(" ]</FONT></NOBR>");
			switch (study.Modality) {
			case "MR":
				print_data(seriesObj.ref_file, 0x00081030, "");
				print_data(seriesObj.ref_file, 0x0008103E, "Seq");
				print_data(seriesObj.ref_file, 0x00180010, "Enh");
				break;
			case "CT":
				print_data(seriesObj.ref_file, 0x00081030, "");
				print_data(seriesObj.ref_file, 0x00181030, "Pro");
				print_data(seriesObj.ref_file, 0x00180010, "Enh");
				break;
			}
			Writer.Write("</DIV></TD>\n<TD ALIGN='CENTER'>");
			Writer.Write("<A HREF='javascript:open_spatial_series_viewer(" + open_spatial_series_viewer_arg(study, seriesObj) + ");'>");
			if (m_browser.type == "NN")
				Writer.Write("<IMG BORDER='" + thumnail_border + "' SRC='");
			else
				Writer.Write("<IMG BORDER='" + thumnail_border + "' STYLE='border-color:#687686;' SRC='");
			Writer.Write(image_url2(study, seriesObj.ref_file.path, vol_config));
			Writer.Write("'></A></TD>\n");
			Writer.Write("</TR>\n");
		}
		Writer.Write("</TABLE>\n");
	}

	//==============================
	//
	//==============================
	void xp_study(DicomStudy dom, StudyObject study, XmlElement vol_config) {
		ArrayList imageObj_list = new ArrayList();

		foreach (SOPInstanceObject f in dom.fl)
			imageObj_list.Add(new ImageObject(dom, f));
		imageObj_list.Sort();

		Writer.Write(thumnail_table_header);
		foreach (ImageObject imageObj in imageObj_list) {
			Writer.Write(thumnail_table_row_heaader(imageObj.file.path));
			Writer.Write("<NOBR><FONT COLOR='white'># ");
			Writer.Write(imageObj.number);
			Writer.Write("</FONT></NOBR>");
			print_data(imageObj.file, 0x00180015, "");
			print_data(imageObj.file, 0x0008103E, "");
			Writer.Write("</DIV></TD>\n<TD ALIGN='CENTER'>");
			Writer.Write("<A HREF='javascript:open_xp_study_viewer(" + open_xp_study_viewer_arg(study, imageObj.file.path) + ");'>");
			if (m_browser.type == "NN")
				Writer.Write("<IMG BORDER='" + thumnail_border + "' SRC='");
			else
				Writer.Write("<IMG BORDER='" + thumnail_border + "' STYLE='border-color:#687686;' SRC='");
			Writer.Write(image_url2(study, imageObj.file.path, vol_config));
			Writer.Write("'></A></TD>\n");
			Writer.Write("</TR>\n");
		}
		Writer.Write("</TABLE>\n");
	}

	//==============================
	//
	//==============================
	void series_list(StudyObject study, XmlElement vol_config) {
		DicomStudy dom = null;
		StudyCache dw_obj = (StudyCache)Application.Get("StudyDOM");
		if (study.SERVER != null) {
			String studyLoc = "http://" + study.SERVER + "/DIOWave/scripts/dio-study.isa" + study.LOCATION + "/" + study.PATH;
			dom = dw_obj.GetRemoteDicomStudy(studyLoc);
		} else {
			String dir = vol_config.SelectSingleNode("directory").InnerText;
			String studyLoc = vol_config.SelectSingleNode("location").InnerText + "/" + study.PATH;
			if (dir.StartsWith("\\")) {
				dom = dw_obj.GetRemoteDicomStudy("http://localhost/DIOWave/scripts/dio-study.isa" + studyLoc);
			} else {
				dom = dw_obj.GetDicomStudy(studyLoc);
			}
		}
	
		String modality = study.Modality;
		if (modality == "CR" || modality == "DX" || modality == "NM" || modality == "SC")
			xp_study(dom, study, vol_config);
		else
			spatial_study(dom, study, vol_config);
	}

	//==============================
	//
	//==============================
	void single_study(ArrayList study_list, UInt32 num_studies, XmlDocument config_dom) {
		StudyObject study = (StudyObject)study_list[0];

		XmlElement vol_config = (XmlElement)config_dom.SelectSingleNode("/DIOWaveConfiguration/VOLUME[@label=\"" + study.VOLUME + "\"]");

		Writer.Write("<DIV CLASS='PATIENT-INFO'><FONT COLOR='white'>");
		Writer.Write("<A STYLE='color:white;' HREF='javascript:FBPI(\"" + study.PatientID + "\");'>" + study.PatientID + "</A><BR>\n");
		Writer.Write(study.PatientName + "<BR>\n");
		Writer.Write("<A STYLE='color:white;' HREF='javascript:FBSD(\"" + study.StudyDate + "\");'>" + prettyDate(study.StudyDate) + "</A> " + prettyTime(study.StudyTime) + " ");
		Writer.Write(study.Modality + (study.StudyID.Length > 0 ? ':' + study.StudyID : ""));
		if (has_reporting_system) {
			report_link_init();
			Writer.Write(report_link(study));
			report_link_uninit();
		}
		Writer.Write("</FONT></DIV>\n");
	
		Writer.Write("<HR>\n");

		series_list(study, vol_config);

		Writer.Write("<HR>\n");
	}

	//==============================
	//
	//==============================
	void patient_list(ArrayList study_list, UInt32 num_studies, XmlDocument config_dom) {
		print_num_studies(num_studies);
		bool first = true;
		String last_vol = null;
		XmlElement vol_config = null;
		if (has_reporting_system)
			report_link_init();
		foreach (StudyObject study in study_list) {
			if (first) {
				Writer.Write("<DIV CLASS='PATIENT-INFO'><FONT COLOR='white'>");
				Writer.Write(study.PatientID + "<BR>\n");
				Writer.Write(study.PatientName + "\n");
				Writer.Write("</FONT></DIV>\n");
				Writer.Write("<HR>\n");
				first = false;
			}
			Writer.Write("<DIV CLASS='PATIENT-STUDY'>");
			Writer.Write("<A HREF='javascript:FBSD(\""+ study.StudyDate + "\");'>" + prettyDate(study.StudyDate) + "</A> " + prettyTime(study.StudyTime) + " ");
			Writer.Write("<A " + modality_style(study) + " HREF='javascript:FBSQ(" + expand_study_arg(study) + ");'>" + study.Modality + (study.StudyID.Length > 0 ? ':' + study.StudyID : "") + "</A>");
			if (has_reporting_system)
				Writer.Write(report_link(study));
			Writer.Write("</DIV>\n");

			if (last_vol != study.VOLUME) {
				last_vol = study.VOLUME;
				vol_config = (XmlElement)config_dom.SelectSingleNode("/DIOWaveConfiguration/VOLUME[@label=\"" + last_vol + "\"]");
			}
			series_list(study, vol_config);

			Writer.Write("<HR>\n");
		}
		if (has_reporting_system)
			report_link_uninit();
	}

	//==============================
	//
	//==============================
	void thumnail_list(ArrayList study_list, UInt32 num_studies, XmlDocument config_dom) {
		print_num_studies(num_studies);
		Writer.Write("<HR>\n");
		String last_vol = null;
		XmlElement vol_config = null;
		if (has_reporting_system)
			report_link_init();
		foreach (StudyObject study in study_list) {
			if (last_vol != study.VOLUME) {
				last_vol = study.VOLUME;
				vol_config = (XmlElement)config_dom.SelectSingleNode("/DIOWaveConfiguration/VOLUME[@label=\"" + last_vol + "\"]");
			}
			Writer.Write("<DIV CLASS='thumnail'>\n");
			Writer.Write("<IMG ALIGN='LEFT' BORDER='0' SRC='" + image_url(study, vol_config) + "'>\n");
			if (m_browser.type == "NN")
				Writer.Write("<DIV STYLE='margin-left:4px;line-height:125%;'>\n");
			else
				Writer.Write("<DIV STYLE='margin-left:58px;line-height:125%;'>\n");
			Writer.Write("<A HREF='javascript:FBSD(\"" + study.StudyDate + "\");'>" + prettyDate(study.StudyDate) + "</A> " + prettyTime(study.StudyTime));
			Writer.Write("<BR>\n");
			Writer.Write("<A HREF='javascript:FBPI(\"" + study.PatientID + "\");'>" + study.PatientID + "</A><BR>\n");
			Writer.Write(study.PatientName + "</DIV>\n");
			Writer.Write("<DIV STYLE='text-align:right;margin-right:4pt;'>\n");
			Writer.Write("<A " + modality_style(study) + " HREF='javascript:FBSQ(" + expand_study_arg(study) + ");'>" + study.Modality + (study.StudyID.Length > 0 ? ':' + study.StudyID : "") + "</A>");
			if (has_reporting_system)
				Writer.Write(report_link(study));
			Writer.Write("</DIV>\n");
			Writer.Write("</DIV><HR>\n");
		}
		if (has_reporting_system)
			report_link_uninit();
	}

	//==============================
	//
	//==============================
	void text_list(ArrayList study_list, UInt32 num_studies) {
		print_num_studies(num_studies);
		String lastDate = "";
		foreach (StudyObject study in study_list) {
			if (lastDate != study.StudyDate) {
				Writer.Write("<DIV CLASS='date'><A HREF='javascript:FBSD(\"" + study.StudyDate + "\");'>" + prettyDate(study.StudyDate) + "</A></DIV>\n");
				lastDate = study.StudyDate;
			}
			Writer.Write("<DIV CLASS='study'>");
			Writer.Write("<NOBR><A HREF='javascript:FBPI(\"" + study.PatientID + "\");'>" + study.PatientID + "</A>");
			Writer.Write("&nbsp;&nbsp;<A " + modality_style(study) + " HREF='javascript:FBSQ(" + expand_study_arg(study) + ");'>" + study.Modality + (study.StudyID.Length > 0 ? ':' + study.StudyID : "") + "</A></NOBR><BR>");
			Writer.Write("<NOBR>" + study.PatientName + "</NOBR>");
			Writer.Write("</DIV>\n");
		}
	}


	//==============================
	//
	//==============================
	void day_list(ArrayList study_list, UInt32 num_studies, QueryStringValue qsv) {

		String query = String.Empty;
		if (qsv.PatientID != null)
			query += "&PatientID=" + qsv.PatientID + "&PatientID-OP=" + qsv.PatientID_OP;
		if (qsv.PatientName != null)
			query += "&PatientName=" + qsv.PatientName + "&PatientName-OP=" + qsv.PatientName_OP;
		if (qsv.PatientID != null && qsv.PatientName != null)
			query += "&Patient-COMB=" + qsv.Patient_COMB;
		if (qsv.Modality != null)
			query += "&Modality=" + qsv.Modality;

		print_num_studies(num_studies);

		Writer.Write("<PRE>\n");

		String lastDate = String.Empty;
		UInt32 studyCount = 0;
		foreach (StudyObject study in study_list) {
			if (lastDate == study.StudyDate) {
				studyCount++;
			} else {
				if (studyCount > 0)
					Writer.Write(" <A HREF='javascript:FBQ(\"&StudyDate=" + lastDate + query + "\");'>(" + studyCount + ")</A>\n");
				Writer.Write("<A HREF='javascript:FBSD(\"" + study.StudyDate + "\");'>" + prettyDate(study.StudyDate) + "</A> ");
				lastDate = study.StudyDate;
				studyCount = 1;
			}
		}
		Writer.Write(" <A HREF='javascript:FBQ(\"&StudyDate=" + lastDate + query + "\");'>(" + studyCount + ")</A>\n");

		Writer.Write("</PRE>\n");
	}

	//==============================
	//
	//==============================
	void main(QueryStringValue qsv, XmlDocument config_dom) {
		
		ArrayList study_list = build_study_list(gen_sql(qsv), config_dom, qsv);
		UInt32 num_studies = (UInt32)study_list.Count;
		if (num_studies == 0) {
			print_num_studies(0);
		} else if (num_studies == 1) {
			single_study(study_list, num_studies, config_dom);
		} else if (num_studies <= 32) {
			if (single_patient(study_list)) {
				patient_list(study_list, num_studies, config_dom);
			} else {
				thumnail_list(study_list, num_studies, config_dom);
			}
		} else if (num_studies <= 256) {
			text_list(study_list, num_studies);
		} else {
			day_list(study_list, num_studies, qsv);
		}
	}

//========================================================================================
</script>
<%
//========================================================================================
	setup(Request);
	XmlDocument config_dom = (XmlDocument)Application.Get("DIOWaveConf");
	server_list = config_dom.SelectNodes("/DIOWaveConfiguration/REMOTE-DIOWAVE");
	QueryStringValue qsv = new QueryStringValue(Request);
	Writer = Response.Output;
//========================================================================================
%>
<HEAD>
<META HTTP-EQUIV="Content-Type" CONTENT="text/html; charset="utf-8">
</HEAD>
<STYLE TYPE="text/css">
/****************************************************************************************/
A { color:#E0E0C0; }
SPAN { color:#E0E0C0; }
NOBR { color:#E0E0C0; }

BODY {
	color:#F0F0D0;
	margin: 0 0 0 0;
	padding: 0 0 0 0;
<% if (m_browser.os == "M") { %>
	font-size:10pt;
	font-family:Verdana;
<% } else if (m_browser.os == "W") { %>
	font-size:10pt;
	font-family:Verdana;
<% } else { %>
	font-size:10pt;
<% } %>

	background-color:#1E2328;
}

DIV.NUM-STUIDES {
	padding-left: 6pt;
	background-color:#606060;
}

DIV.PATIENT-INFO {
	background-color:black;
	padding-left: 8pt;
}

DIV.PATIENT-STUDY {
	padding-left: 4pt;
}

DIV.thumnail {
	font-size:10pt;
	margin-left:4pt;
}
DIV.date {
	font-size:12pt;
	margin-left:8pt;
	margin-top:3pt;
	margin-bottom:0;
}
DIV.study {
	font-size:10pt;
	margin-left:16pt;
	margin-top:2pt;
	margin-bottom:0;
	text-indent: -12pt;
	padding-left: 12pt;
}

DIV.SERIES-INFO {
	font-size:9pt;
	overflow: hidden;
	width: <%=thumnail_series_info_width%>;
	white-space: nowrap;
	text-overflow: ellipsis;
}

PRE {
	margin-left:6pt;
}

A.HB:hover {
	background-color:#687686;
	font-weight:bold;
	color:#F0F0D0;
}

A.HB {
	padding: 2 2 2 2;
	color:white;
	text-decoration:none;
	font-size:10pt;
}
/****************************************************************************************/
</STYLE>
<SCRIPT LANGUAGE=JavaScript>
//----------------------------------------------------------------------------------------

//------------------------------
//
//------------------------------
function FBQ(query) {
	top.find_study('q', query);
}
//------------------------------
//
//------------------------------
function FBSD(date) {
	top.find_study('d', '&StudyDate=' + escape(date));
}
//------------------------------
//
//------------------------------
function FBPI(pid) {
	top.find_study('p', '&PatientID=' + escape(pid) + '&PatientID-OP=EQ');
}
//------------------------------
//
//------------------------------
function FBSQ(server, seq_no, pid, date, modality) {
	top.find_study('s', '&SEQ_NO=' + escape(seq_no) + (server.length == 0 ? '' : '&SERVER=' + server) + '&PatientID=' + escape(pid) + '&PatientID-OP=EQ&StudyDate=' + escape(date) + '&Modality=' + escape(modality));
}

//------------------------------
//
//------------------------------
var selected_series_elm = null;
function hilite_opened_series(id) {
<% if (m_browser.type == "GE" || m_browser.type == "IE") { %>
	if (selected_series_elm != null)
		selected_series_elm.style.backgroundColor = "#1E2328";
	selected_series_elm = document.getElementById(id);
	selected_series_elm.style.backgroundColor = "#687686";
<% } %>
}

//------------------------------
//
//------------------------------
function open_spatial_series_viewer(server, volume, path, series_uid) {
	top.VIEW.location.href = (server.length == 0 ? 'spatial-series-viewer.aspx' : 'http://' + server + '<%=Request.ApplicationPath%>/spatial-series-viewer.aspx')
		+ '?WW='  + <%=view_frame_width(server_list.Count != 0)%>
		+ '&WH='  + <%=view_frame_height(server_list.Count != 0)%>
		+ '&VOLUME=' + escape(volume)
		+ '&PATH=' + escape(path)
		+ '&SERIES=' + escape(series_uid);

	hilite_opened_series(series_uid);
}
//------------------------------
//
//------------------------------
function open_xp_study_viewer(server, volume, path, image_path) {
	top.VIEW.location.href = (server.length == 0 ? 'xp-study-viewer.aspx' : 'http://' + server + '<%=Request.ApplicationPath%>/xp-study-viewer.aspx')
		+ '?WW=' + <%=view_frame_width(server_list.Count != 0)%>
		+ '&WH=' + <%=view_frame_height(server_list.Count != 0)%>
		+ '&VOLUME=' + escape(volume)
		+ '&PATH=' + escape(path)
		+ '&IMAGE=' + escape(image_path);

	hilite_opened_series(image_path);
}


//------------------------------
//
//------------------------------
<%=open_report_func()%>

//----------------------------------------------------------------------------------------
</SCRIPT>
<BODY>
<DIV STYLE="padding: 0 0 0 0; margin: 0 0 0 0;">
<IMG SRC="/DIOWave/DWVS-LOGO.gif" BORDER="0" ALIGN="TOP">
<TABLE WIDTH="100%" ALIGN="CENTER" HSPACE="0" VSPACE="0" CELLPADDING="0" CELLSPACING="0" BORDER="0" STYLE="padding:6 0 6 0;margin:0 0 0 0;background-color:black;"><TR>
<TD ALIGN="CENTER" NOWRAP><A CLASS="HB" HREF="javascript:top.open_query_page();">New Query</A></TD>
<TD ALIGN="CENTER" NOWRAP><A CLASS="HB" HREF="javascript:top.find_study_back();">Previous List</A></TD>
</TR></TABLE>
</DIV>
<%
//========================================================================================
	main(qsv, config_dom);
//========================================================================================
%>
</BODY>
</HTML>
